// MakeZHDB GUIDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MakeZHDB GUI.h"
#include "MakeZHDB GUIDlg.h"
#include <stdlib.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMakeZHDBGUIDlg dialog

CMakeZHDBGUIDlg::CMakeZHDBGUIDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMakeZHDBGUIDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMakeZHDBGUIDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMakeZHDBGUIDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMakeZHDBGUIDlg)
	DDX_Control(pDX, IDC_OUTFILE, m_output);
	DDX_Control(pDX, IDC_HELIOTYPE, m_heliotype);
	DDX_Control(pDX, IDC_HELIONAME, m_helioname);
	DDX_Control(pDX, IDC_SOURCEFILE, m_source);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMakeZHDBGUIDlg, CDialog)
	//{{AFX_MSG_MAP(CMakeZHDBGUIDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_SOURCE, OnSource)
	ON_BN_CLICKED(IDC_OUTPUTDIR, OnOutput)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMakeZHDBGUIDlg message handlers

BOOL CMakeZHDBGUIDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	
	::GetCurrentDirectory( 8192, m_homepath.GetBuffer(8192) );
	m_homepath.ReleaseBuffer();
	m_homepath = m_homepath + "\\MakeZHDB GUI.cfg";
	CFile settings;
	if (settings.Open( m_homepath, CFile::modeRead )) {
		CString out;
		CArchive ar(&settings, CArchive::load);
		ar >> out;
		ar.Close();
		settings.Close();

		m_output.SetWindowText(out);
		m_output.SetSel(out.GetLength(), out.GetLength() );
	}


	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CMakeZHDBGUIDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMakeZHDBGUIDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMakeZHDBGUIDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CMakeZHDBGUIDlg::OnSource() 
{
	CFileDialog *dlg;
	int id;
	CString path, opath;
	char path_buffer[_MAX_PATH];
	char drive[_MAX_DRIVE];
	char dir[_MAX_DIR];
	char fname[_MAX_FNAME];
	char type[_MAX_EXT];

	m_source.GetWindowText(path);

	dlg = new CFileDialog( TRUE, "", path, OFN_HIDEREADONLY, "Convertable Files|*.bas;*.pdb;*.bmp;*.jpg;*.hex;*.gam;*.z;*.z3;*.z5;*.txt;*.doc|All Files (*.*)|*.*||", this);

	id = dlg->DoModal();
	switch(id) {
	case IDCANCEL:
		break;
	case IDOK:
		m_source.SetWindowText(dlg->GetPathName());
		m_source.SetSel(8192, 8192);
		strcpy(path_buffer, dlg->GetPathName());
		_splitpath( path_buffer, NULL, dir, fname, type );
		if (!stricmp(".bas", type)) {
			m_heliotype.SetWindowText("BASIC");
		} else if (!stricmp(".pdb", type)) {
			m_heliotype.SetWindowText("FontPDB");
		} else if (!stricmp(".jpg", type) || !stricmp(".bmp", type)) {
			m_heliotype.SetWindowText("GrayscaleFile2");
		} else if (!stricmp(".hex", type)) {
			m_heliotype.SetWindowText("Hugo");
		} else if (!stricmp(".gam", type)) {
			m_heliotype.SetWindowText("TADS");
		} else if (!stricmp(".z3", type) || !stricmp(".z5", type) || !stricmp(".z", type)) {
			m_heliotype.SetWindowText("Frotz");
		} else if (!stricmp(".txt", type) || !stricmp(".doc", type)) {
			m_heliotype.SetWindowText("Text");
		}
		m_helioname.SetWindowText(fname);
		m_output.GetWindowText(opath);
		strcpy(path_buffer, opath);
		_splitpath( path_buffer, drive, dir, NULL, NULL);
		sprintf(path_buffer, "%s%s%s.hdb", drive, dir, fname);
		m_output.SetWindowText(path_buffer);
		break;
	}
	
	delete dlg;
}

void CMakeZHDBGUIDlg::OnOutput() 
{
	CFileDialog *dlg;
	int id;
	CString path;

	m_output.GetWindowText(path);
	dlg = new CFileDialog( FALSE, ".hdb", path, OFN_OVERWRITEPROMPT, "Output ZHDB File (*.hdb)|*.hdb|All Files (*.*)|*.*||", this);

	id = dlg->DoModal();
	switch(id) {
	case IDCANCEL:
		break;
	case IDOK:
		m_output.SetWindowText(dlg->GetPathName());
		m_output.SetSel(8192, 8192);
		break;
	}

	delete dlg;
	
}

extern "C" {
	void MakeOneZHDB(char *recordName, char *owner, int size, unsigned char *data, char *outFile);
	int LoadBMP2Gray( char *filename, int *xsize, int *ysize, unsigned char **data, HWND hwnd);
	void PackGray2LCD( int x, int y, unsigned char *data, unsigned char **pack, unsigned int *size );
	void MakeOneHDB(char *recordName, char *owner, int size, unsigned char *data, char *outFile);
	void ScaleImage(unsigned char *in, unsigned char **out, int xin, int yin, int *xout, int *yout);
	int LoadJPG2Gray( char *filename, int *xsize, int *ysize, unsigned char **data, HWND hwnd);
	unsigned char *Normalize(int size, unsigned char *source);
	unsigned char *Dither(int xsize, int ysize, unsigned char *source);
}

void CMakeZHDBGUIDlg::OnOK() 
{
	CFile settings;
	CString out, in, htype, hname;
	FILE *fp;
	unsigned char *buff;
	int sz;

	m_output.GetWindowText(out);
	m_source.GetWindowText(in);
	m_heliotype.GetWindowText(htype);
	m_helioname.GetWindowText(hname);

	if (settings.Open( m_homepath, CFile::modeCreate | CFile::modeWrite )) {
		CArchive ar(&settings, CArchive::store);
		ar << out;
		ar.Close();
		settings.Close();
	}


	if (strcmp(htype, "GrayscaleFile2")) {
		fp=fopen(in, "rb");
		if (fp==NULL) {
			MessageBox( "Unable to read source file", "Fatal Error", MB_ICONSTOP );
			return;
		}
		fseek(fp,0,SEEK_END);
		sz=ftell(fp);
		fseek(fp,0,SEEK_SET);
		buff=(unsigned char *)malloc(sz);
		fread(buff,sz,1,fp);
		fclose(fp);

		MakeOneZHDB(hname.GetBuffer(0), htype.GetBuffer(0), sz, buff, out.GetBuffer(0));
	} else {
		int x, y, xscale, yscale;
		unsigned char *data, *scale, *pack, *packscale;
		unsigned int size, sizescale;
		char *infile;
		int ok;

		infile = in.GetBuffer(0);
		if (stricmp(".jpg", infile+strlen(infile)-4)==0)
			ok = LoadJPG2Gray( in.GetBuffer(0), &x, &y, &data, m_hWnd );
		else
			ok = LoadBMP2Gray( in.GetBuffer(0), &x, &y, &data, m_hWnd );
//		printf("Input BMP Size: %d x %d\n", x, y);
		if (!ok) return;

		PackGray2LCD( x, y, data, &pack, &size );
		
		ScaleImage( data, &scale, x, y, &xscale, &yscale );
//		printf("Scaled Size: %d x %d\n", xscale, yscale);
		PackGray2LCD( xscale, yscale, scale, &packscale, &sizescale );
		
		data = (unsigned char *)malloc(size+sizescale);
		memcpy(data, pack, size);
		memcpy(data+size,packscale, sizescale);

		MakeOneZHDB(hname.GetBuffer(0), htype.GetBuffer(0), size+sizescale, data, out.GetBuffer(0));
//		MakeOneZHDB(desc, "GrayscaleFile2", size+sizescale, data, outfile);

	}


	CDialog::OnOK();
}
